import logging
from lib.ahConfig import ahConfig
import os
from os import path
from os import listdir
from datetime import datetime

from PIL import Image
import sys
import shutil
from io import BytesIO


import base64
import urllib.request
import urllib.parse
import urllib.error
import json
import logs
log = logging.getLogger('logs.' + __name__)
log.debug("Instatiated ImageOps Class")

class ahImageOps:

    def __init__(self, imgString): 
        
        
        log.info("Instatiated ImageOps Class")
        #start with a base64 string of the image
        
        #data['img'] = imgString
        im = Image.open(BytesIO(base64.b64decode(imgString)))
        self.image = im
        #now this class owns the image
        
   
                    
                
    
    def compressImage(self):
       
        file_path = path.join(passthru, sf)
        picture = Image.open(file_path)
        dim = picture.size
        picture.save(file_path, "JPEG", optimize=True, quality=qual)
        processed_size = os.stat(file_path).st_size
        return processed_size
    
    def resizeImage(self):
        
        try:
            log.info("resizing image")
            dims = self.image
            dimsSize = dims.size
            log.debug("original size is {}".format(dimsSize))
            oldX = dimsSize[0]
            oldY = dimsSize[1]
            newX = int(oldX - (oldX * 0.6))
            newY = int(oldY - (oldY * 0.6))
            dims = dims.resize((newX,newY), Image.ANTIALIAS)
            log.info("image is resized. not saved yet")
            #dims.save(path.join(passthru, sf), optimize=True, quality=95)
            img_byte_arr = BytesIO()
            dims.save(img_byte_arr, format='png', optimize=True, quality=65)
            log.info("image is saved to bytes array and compressed" )
            backToB64 = base64.b64encode(img_byte_arr.getvalue())
            log.debug("this is backto64")
            log.debug(str(backToB64.decode('utf-8'))[0:30])
            
            #log.info("Converted image to {}")
            return str(backToB64.decode('utf-8'))
            
            #convert bytes array back to base64
            
            
        except MemoryError:
            log.critical("failed to resize image -- MemoryError")
        except Exception as e:
            log.critical("failed to resize image")
            log.critical("Exception: {}".format(e))
            log.critical(repr(e))
            sys.exit(1)
   